unit ClientSockets;

interface

uses
  SysUtils, Classes, ScktComp, WinSock;

type
  TNagleClientSocket = class(TClientSocket)
  private
    FUsenagle: Boolean;
    procedure SetUsenagle(const Value: Boolean);
    { Private declarations }
  protected
    { Protected declarations }
    procedure DoActivate(Value: Boolean); override;
  public
    { Public declarations }
    constructor Create(AOwner: TComponent); override;
  published
    { Published declarations }
    property Usenagle : Boolean read FUsenagle write SetUsenagle;
  end;

  TNagleServerSocket  = class(TServerSocket)
  private
    FUsenagle: Boolean;
    procedure SetUsenagle(const Value: Boolean);
  protected
    procedure DoActivate(Value: Boolean); override;
  public
    constructor Create(AOwner: TComponent); override;
  published
    property Usenagle : Boolean read FUsenagle write SetUsenagle;
  end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('ERG Lib', [TNagleClientSocket, TNagleServerSocket]);
end;

{ TNagleClientSocket }

constructor TNagleClientSocket.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  UseNagle := true;
end;

procedure TNagleClientSocket.DoActivate(Value: Boolean);
var Delay : integer;
begin
  inherited;
  if Value then
  begin
    if not UseNagle then
    begin
      Delay := 1;
      setsockopt(socket.SocketHandle,IPPROTO_TCP,TCP_NODELAY,PAnsiChar(@Delay),SizeOf(Delay));
    end;
  end;
end;

procedure TNagleClientSocket.SetUsenagle(const Value: Boolean);
begin
  FUsenagle := Value;
end;

{ TNagleServerSocket }

constructor TNagleServerSocket.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  UseNagle := true;
end;

procedure TNagleServerSocket.DoActivate(Value: Boolean);
var Delay : integer;
begin
  inherited;
  if Value then
  begin
    if not UseNagle then
    begin
      Delay := 1;
      setsockopt(socket.SocketHandle,IPPROTO_TCP,TCP_NODELAY,PAnsiChar(@Delay),SizeOf(Delay));
    end;
  end;
end;

procedure TNagleServerSocket.SetUsenagle(const Value: Boolean);
begin
  FUsenagle := Value;
end;

end.
